;*******************************************************************************
;  Filename:    FONCT_LEVEL.asm                                                *
;                                                                              *
;  Version:  	01/03/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Fonction permettant calcul DB(OUT)=DB(IN1)+DB(IN2) avec MINI et MAXI        *
;                                                                              *
;   Param_1     Variable IN1                                                   *
;   Param_2     Variable IN2                                                   *
;   Param_3     MINI pour Variable OUT                                         *
;   Param_4     MAXI pour Variable OUT                                         *
;                                                                              *
;   Param_5     Variable OUT                                                   *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;**************** MODULES et VARIABLES EXTERNES ********************************
	
	extern  temp1,param_1,param_2,param_3,param_4,param_5

	extern  Main

;************************* SOUS ROUTINE ****************************************

PROG            CODE

FONCT_LEVEL
                global FONCT_LEVEL

;--------------------------- OUT LEVEL 1 ---------------------------------------
                movff   param_1,temp1       ; Variable -> Temp1
                movlw   d'192'              ; point 0
                subwf   temp1,1             ; temp1 = temp1 - 192
                btfss   temp1,7
                goto    positif
                                            ;----Traitement NEGATIF-------------
                negf    temp1               ; Negatif -> Positif
                movf    param_2,0           ; W = MASTER_Val
                cpfslt  temp1               ; Saute si temp1 < Master_Val
                goto    depas_Mini
                negf    temp1               ; Positif -> Negatif
                movf    temp1,0             ; W=temp1
                addwf   param_2,0           ; W = MASTER +/- temp1
                movwf   temp1               ; temp1 = W
                movff   temp1,param_5       ; temp1 -> Rsultat
                goto    Exit

positif         movf    param_2,0           ;----Traitement POSITIF-------------
                cpfsgt  param_4             ; MAX > MASTER_Val
                goto    depas_Maxi
                movf    param_2,0           ; W = MASTER_Val
                subwf   param_4,0           ; W = MAX - MASTER_Val
                cpfsgt  temp1               ; Saute si temp1 > MAX - MASTER_Val
                goto    traitement
depas_Maxi      movff   param_4,param_5     ; Maxi -> OUT
                goto    Exit

traitement      movf    temp1,0             ; W=temp1
                addwf   param_2,0           ; W = MASTER +/- temp1
                movwf   temp1               ; temp1 = W
                movff   temp1,param_5       ; temp1 -> Rsultat
                goto    Exit

depas_Mini      movff   param_3,param_5     ; Mini -> OUT
                
;****************************** FIN ********************************************
Exit            return                  ; retour du sous programme
			    END
