;*******************************************************************************
;  Filename:    VAR_Management.asm                                            *
;                                                                              *
;  Version:  	13/02/2013    V1.0      Version originale                      *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                 			                       *
;  Gestion des variables dans les memus                                                           *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
    #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern Main

;********************** VARIABLES EXTERNES *************************************
    extern      memo1,memo2,memo3,pages,champ
    extern      temp1,temp2,temp3,temp4,temp5,temp6

    extern      OFFSET_1,OFFSET_2,OFFSET_3,OFFSET_4,OFFSET_5,OFFSET_6
    extern      OFFSET_7,OFFSET_8,OFFSET_Min,OFFSET_Max
    extern      MAX_1,MAX_2,MAX_3,MAX_4,MAX_5,MAX_6,MAX_7,MAX_8
    extern      MAX_Min,MAX_Max,BALANCE,BALANCE_Max,BALANCE_Min

    extern      CONTRAST_ECO,CONTRAST_MAX,CONTRAST_TEMPO,LED_ECO,LED_MAX
    extern      TON_REL_1,TOF_REL_1,TON_REL_2,TOF_REL_2,TON_REL_3,TOF_REL_3
    extern      TOF_VFD_OFF,POTAR_Max,VOLUME_CONF,MASTER_Min,MASTER_Max

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Management_VAR
                global Management_VAR

;************** PAGES 11 a 18 **************************************************
                movlw   d'10'           ; > PAGE N
                cpfsgt  pages
                goto    pages_21
                movlw   d'19'           ; < PAGE N
                cpfslt  pages
                goto    pages_21
;-------------- Variables PAGE 11 ------------------------ PAGE_OUT 1 ----------
pages_11        movlw   d'11'           ; pages N
                cpfseq  pages
                goto    pages_12         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_11c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_11b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_1           ; Si Variable = Max alors saute
                incf    MAX_1,1         ; SI OUI incrementation
pages_11b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_11c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_1           ; Si Variable = Min alors saute
                decf    MAX_1,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_11c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_11e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_11d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_1        ; Si Variable = Max alors saute
                incf    OFFSET_1,1      ; SI OUI incrementation
pages_11d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_11e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_1        ; Si Variable = Min alors saute
                decf    OFFSET_1,1      ; SI OUI decrementation
pages_11e

;-------------- Variables PAGE 12 ----------------------- PAGE_OUT 2 -----------
pages_12         movlw   d'12'           ; pages N
                cpfseq  pages
                goto    pages_13         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_12c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_12b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_2           ; Si Variable = Max alors saute
                incf    MAX_2,1         ; SI OUI incrementation
pages_12b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_12c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_2           ; Si Variable = Min alors saute
                decf    MAX_2,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_12c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_12e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_12d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_2        ; Si Variable = Max alors saute
                incf    OFFSET_2,1      ; SI OUI incrementation
pages_12d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_12e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_2        ; Si Variable = Min alors saute
                decf    OFFSET_2,1      ; SI OUI decrementation
pages_12e

;-------------- Variables PAGE 13 ----------------------- PAGE_OUT 2 -----------
pages_13         movlw   d'13'           ; pages N
                cpfseq  pages
                goto    pages_14         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_13c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_13b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_3           ; Si Variable = Max alors saute
                incf    MAX_3,1         ; SI OUI incrementation
pages_13b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_13c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_3           ; Si Variable = Min alors saute
                decf    MAX_3,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_13c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_13e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_13d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_3        ; Si Variable = Max alors saute
                incf    OFFSET_3,1      ; SI OUI incrementation
pages_13d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_13e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_3        ; Si Variable = Min alors saute
                decf    OFFSET_3,1      ; SI OUI decrementation
pages_13e
;-------------- Variables PAGE 14 ----------------------- PAGE_OUT 4 -----------
pages_14         movlw   d'14'           ; pages N
                cpfseq  pages
                goto    pages_15         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_14c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_14b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_4           ; Si Variable = Max alors saute
                incf    MAX_4,1         ; SI OUI incrementation
pages_14b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_14c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_4           ; Si Variable = Min alors saute
                decf    MAX_4,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_14c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_14e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_14d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_4        ; Si Variable = Max alors saute
                incf    OFFSET_4,1      ; SI OUI incrementation
pages_14d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_14e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_4        ; Si Variable = Min alors saute
                decf    OFFSET_4,1      ; SI OUI decrementation
pages_14e
;-------------- Variables PAGE 15 ----------------------- PAGE_OUT 5 -----------
pages_15         movlw   d'15'           ; pages N
                cpfseq  pages
                goto    pages_16         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_15c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_15b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_5           ; Si Variable = Max alors saute
                incf    MAX_5,1         ; SI OUI incrementation
pages_15b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_15c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_5           ; Si Variable = Min alors saute
                decf    MAX_5,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_15c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_15e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_15d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_5        ; Si Variable = Max alors saute
                incf    OFFSET_5,1      ; SI OUI incrementation
pages_15d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_15e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_5        ; Si Variable = Min alors saute
                decf    OFFSET_5,1      ; SI OUI decrementation
pages_15e
;-------------- Variables PAGE 16 ----------------------- PAGE_OUT 6 -----------
pages_16         movlw   d'16'           ; pages N
                cpfseq  pages
                goto    pages_17         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_16c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_16b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_6           ; Si Variable = Max alors saute
                incf    MAX_6,1         ; SI OUI incrementation
pages_16b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_16c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_6           ; Si Variable = Min alors saute
                decf    MAX_6,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_16c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_16e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_16d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_6        ; Si Variable = Max alors saute
                incf    OFFSET_6,1      ; SI OUI incrementation
pages_16d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_16e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_6        ; Si Variable = Min alors saute
                decf    OFFSET_6,1      ; SI OUI decrementation
pages_16e
;-------------- Variables PAGE 17 ----------------------- PAGE_OUT 7 -----------
pages_17         movlw   d'17'           ; pages N
                cpfseq  pages
                goto    pages_18         ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_17c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_17b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_7           ; Si Variable = Max alors saute
                incf    MAX_7,1         ; SI OUI incrementation
pages_17b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_17c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_7           ; Si Variable = Min alors saute
                decf    MAX_7,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_17c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_17e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_17d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_7        ; Si Variable = Max alors saute
                incf    OFFSET_7,1      ; SI OUI incrementation
pages_17d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_17e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_7        ; Si Variable = Min alors saute
                decf    OFFSET_7,1      ; SI OUI decrementation
pages_17e
;-------------- Variables PAGE 18 ----------------------- PAGE_OUT 8 -----------
pages_18         movlw   d'18'           ; pages N
                cpfseq  pages
                goto    pages_31        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_18c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_18b        ; SINON GOTO exit
                movf    MAX_Max,0       ; W = Max
                cpfseq  MAX_8           ; Si Variable = Max alors saute
                incf    MAX_8,1         ; SI OUI incrementation
pages_18b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_18c        ; SINON GOTO exit
                movf    MAX_Min,0         ; W = Max
                cpfseq  MAX_8           ; Si Variable = Min alors saute
                decf    MAX_3,1         ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_18c        movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_18e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_18d        ; SINON GOTO exit
                movf    OFFSET_Max,0     ; W = Max
                cpfseq  OFFSET_8        ; Si Variable = Max alors saute
                incf    OFFSET_8,1      ; SI OUI incrementation
pages_18d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_18e        ; SINON GOTO exit
                movf    OFFSET_Min,0     ; W = Max
                cpfseq  OFFSET_8        ; Si Variable = Min alors saute
                decf    OFFSET_8,1      ; SI OUI decrementation
pages_18e
;-------------- Variables PAGE 21 ----------------------- PAGE_LINEAR 1/8 ------
pages_21

;-------------- Variables PAGE 31 ----------------------- PAGE_SYSTEM 1/8 ------
pages_31        movlw   d'31'           ; pages N
                cpfseq  pages
                goto    pages_32        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_31c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_31b       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TON_REL_1       ; Si Variable = Max alors saute
                incf    TON_REL_1,1     ; SI OUI incrementation
pages_31b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_31c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TON_REL_1       ; Si Variable = Min alors saute
                decf    TON_REL_1,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_31c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_31e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_31d       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TOF_REL_1       ; Si Variable = Max alors saute
                incf    TOF_REL_1,1     ; SI OUI incrementation
pages_31d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_31e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TOF_REL_1       ; Si Variable = Min alors saute
                decf    TOF_REL_1,1     ; SI OUI decrementation
pages_31e

;-------------- Variables PAGE 32 ----------------------- PAGE_SYSTEM 1/8 ------
pages_32        movlw   d'32'           ; pages N
                cpfseq  pages
                goto    pages_33        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_32c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_32b       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TON_REL_2       ; Si Variable = Max alors saute
                incf    TON_REL_2,1     ; SI OUI incrementation
pages_32b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_32c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TON_REL_2       ; Si Variable = Min alors saute
                decf    TON_REL_2,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_32c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_32e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_32d       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TOF_REL_2       ; Si Variable = Max alors saute
                incf    TOF_REL_2,1     ; SI OUI incrementation
pages_32d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_32e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TOF_REL_2       ; Si Variable = Min alors saute
                decf    TOF_REL_2,1     ; SI OUI decrementation
pages_32e

;-------------- Variables PAGE 33 ----------------------- PAGE_SYSTEM 1/8 ------
pages_33        movlw   d'33'           ; pages N
                cpfseq  pages
                goto    pages_34        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_33c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_33b       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TON_REL_3       ; Si Variable = Max alors saute
                incf    TON_REL_3,1     ; SI OUI incrementation
pages_33b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_33c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TON_REL_3       ; Si Variable = Min alors saute
                decf    TON_REL_3,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_33c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_33e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_33d       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  TOF_REL_3       ; Si Variable = Max alors saute
                incf    TOF_REL_3,1     ; SI OUI incrementation
pages_33d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_33e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TOF_REL_3       ; Si Variable = Min alors saute
                decf    TOF_REL_3,1     ; SI OUI decrementation
pages_33e

;-------------- Variables PAGE 34 ----------------------- PAGE_SYSTEM 1/8 ------
pages_34        movlw   d'34'           ; pages N
                cpfseq  pages
                goto    pages_35        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_34c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_34b       ; SINON GOTO exit
                movlw   d'200'          ; W = Max
                cpfseq  CONTRAST_TEMPO  ; Si Variable = Max alors saute
                incf    CONTRAST_TEMPO,1     ; SI OUI incrementation
pages_34b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_34c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  CONTRAST_TEMPO  ; Si Variable = Min alors saute
                decf    CONTRAST_TEMPO,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_34c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_34e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_34d       ; SINON GOTO exit
                movlw   d'200'          ; W = Max
                cpfseq  TOF_VFD_OFF     ; Si Variable = Max alors saute
                incf    TOF_VFD_OFF,1   ; SI OUI incrementation
pages_34d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_34e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  TOF_VFD_OFF     ; Si Variable = Min alors saute
                decf    TOF_VFD_OFF,1   ; SI OUI decrementation
pages_34e

;-------------- Variables PAGE 35 ----------------------- PAGE_SYSTEM 1/8 ------
pages_35        movlw   d'35'           ; pages N
                cpfseq  pages
                goto    pages_36        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_35c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_35b       ; SINON GOTO exit
                movlw   d'03'          ; W = Max
                cpfseq  CONTRAST_ECO       ; Si Variable = Max alors saute
                incf    CONTRAST_ECO,1     ; SI OUI incrementation
pages_35b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_35c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  CONTRAST_ECO       ; Si Variable = Min alors saute
                decf    CONTRAST_ECO,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_35c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_35e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_35d       ; SINON GOTO exit
                movlw   d'03'          ; W = Max
                cpfseq  CONTRAST_MAX       ; Si Variable = Max alors saute
                incf    CONTRAST_MAX,1     ; SI OUI incrementation
pages_35d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_35e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  CONTRAST_MAX       ; Si Variable = Min alors saute
                decf    CONTRAST_MAX,1     ; SI OUI decrementation
pages_35e

;-------------- Variables PAGE 36 ----------------------- PAGE_SYSTEM 1/8 ------
pages_36        movlw   d'36'           ; pages N
                cpfseq  pages
                goto    pages_37        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_36c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_36b       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  LED_ECO       ; Si Variable = Max alors saute
                incf    LED_ECO,1     ; SI OUI incrementation
pages_36b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_36c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  LED_ECO       ; Si Variable = Min alors saute
                decf    LED_ECO,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_36c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_36e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_36d       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  LED_MAX       ; Si Variable = Max alors saute
                incf    LED_MAX,1     ; SI OUI incrementation
pages_36d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_36e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  LED_MAX       ; Si Variable = Min alors saute
                decf    LED_MAX,1     ; SI OUI decrementation
pages_36e

;-------------- Variables PAGE 37 ----------------------- PAGE_SYSTEM 1/8 ------
pages_37        movlw   d'37'           ; pages N
                cpfseq  pages
                goto    pages_38        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_37c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_37b       ; SINON GOTO exit
                movlw   d'100'          ; W = Max
                cpfseq  POTAR_Max       ; Si Variable = Max alors saute
                incf    POTAR_Max,1     ; SI OUI incrementation
pages_37b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_37c       ; SINON GOTO exit
                movlw   d'01'           ; W = Max
                cpfseq  POTAR_Max       ; Si Variable = Min alors saute
                decf    POTAR_Max,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_37c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_37e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_37d       ; SINON GOTO exit
                movlw   d'01'          ; W = Max
                cpfseq  VOLUME_CONF       ; Si Variable = Max alors saute
                incf    VOLUME_CONF,1     ; SI OUI incrementation
pages_37d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_37e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  VOLUME_CONF       ; Si Variable = Min alors saute
                decf    VOLUME_CONF,1     ; SI OUI decrementation
pages_37e

;-------------- Variables PAGE 38 ----------------------- PAGE_SYSTEM 1/8 ------
pages_38        movlw   d'38'           ; pages N
                cpfseq  pages
                goto    pages_41        ; Sinon suite
                ;---------------------------------------- Variable MAX ---------
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_38c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_38b       ; SINON GOTO exit
                movlw   d'255'          ; W = Max
                cpfseq  MASTER_Min       ; Si Variable = Max alors saute
                incf    MASTER_Min,1     ; SI OUI incrementation
pages_38b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_38c       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  MASTER_Min       ; Si Variable = Min alors saute
                decf    MASTER_Min,1     ; SI OUI decrementation
                ;---------------------------------------- Variable OFFSET ------
pages_38c       movlw   d'04'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_38e

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_38d       ; SINON GOTO exit
                movlw   d'255'          ; W = Max
                cpfseq  MASTER_Max       ; Si Variable = Max alors saute
                incf    MASTER_Max,1     ; SI OUI incrementation
pages_38d
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_38e       ; SINON GOTO exit
                movlw   d'00'           ; W = Max
                cpfseq  MASTER_Max       ; Si Variable = Min alors saute
                decf    MASTER_Max,1     ; SI OUI decrementation
pages_38e

;-------------- Variables PAGE 41 ----------------------- PAGE_AUDIO_BAL -------
pages_41        movlw   d'41'           ; pages N
                cpfseq  pages
                goto    pages_99        ; Sinon suite
                ;---------------------------------------- Variable BALANCE -----
                movlw   d'03'           ; Selection Champ 3 ?
                cpfseq  champ
                goto    pages_41c

                btfss   memo1,5         ; Si FM SEL+ = 1 -> saut ligne
                goto    pages_41b       ; SINON GOTO exit
                movf    BALANCE_Max,0   ; W = Max
                cpfseq  BALANCE         ; Si Variable = Max alors saute
                incf    BALANCE,1       ; SI NON incrementation
pages_41b
                btfss   memo1,7         ; Si FM SEL- = 1 -> saut ligne
                goto    pages_41c       ; SINON GOTO exit
                movf    BALANCE_Min,0   ; W = Min
                cpfseq  BALANCE         ; Si Variable = Min alors saute
                decf    BALANCE,1       ; SI NON decrementation
pages_41c
;-------------- Variables PAGE 99 ----------------------- XXXXXXXXXXX ----------
pages_99


Exit
;--------------- exit ----------------------------------------------------------
            return              ; retour du sous programme
		
    		END
