;*******************************************************************************
;  Filename:    OUT_LEVEL.asm                                                  *
;                                                                              *
;  Version:  	26/02/2013    V1.0      Version originale pour 16F577          *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Calcul des niveaux pour chaque canal (18)                                  *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;**************** MODULES et VARIABLES EXTERNES ********************************
	
	extern  temp1,param_1,param_2,param_3,param_4,param_5
    extern  MASTER_Val,OFFSET_1,OFFSET_2,OFFSET_3,OFFSET_4
    extern  OFFSET_5,OFFSET_6,OFFSET_7,OFFSET_8,BALANCE
    extern  LEVEL_1,LEVEL_2,LEVEL_3,LEVEL_4,LEVEL_5,LEVEL_6,LEVEL_7,LEVEL_8
    extern  MAX_1,MAX_2,MAX_3,MAX_4,MAX_5,MAX_6,MAX_7,MAX_8
    extern  MUTE_ENABLE,LINEAR_ENABLE
    extern  LINEAR_1_Val,LINEAR_2_Val,LINEAR_3_Val,LINEAR_4_Val
    extern  LINEAR_5_Val,LINEAR_6_Val,LINEAR_7_Val,LINEAR_8_Val

	extern  Main,FONCT_LEVEL

;************************* SOUS ROUTINE ****************************************

PROG            CODE

OUT_LEVEL
                global OUT_LEVEL

;--------------------------- OUT LEVEL 1 ---------------------------------------
                movff   OFFSET_1,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_1,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_1     ; Variable OUT - > parametre

;--------------------------- OUT LEVEL 2 ---------------------------------------
                movff   OFFSET_2,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_2,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_2     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 3 ---------------------------------------
                movff   OFFSET_3,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_3,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_3     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 4 ---------------------------------------
                movff   OFFSET_4,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_4,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_4     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 5 ---------------------------------------
                movff   OFFSET_5,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_5,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_5     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 6 ---------------------------------------
                movff   OFFSET_6,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_6,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_6     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 7 ---------------------------------------
                movff   OFFSET_7,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_7,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_7     ; Variable OUT - > parametre
;--------------------------- OUT LEVEL 8 ---------------------------------------
                movff   OFFSET_8,param_1    ; Variable IN1 - > parametre
                movff   MASTER_Val,param_2  ; Variable IN1 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_8,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_8     ; Variable OUT - > parametre

;----------------------------- BALANCE -----------------------------------------

                movlw   d'192'
                cpfsgt  BALANCE             ; Si Balance > 192
                goto    suite_BAL

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_2,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_2,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_2     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_4,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_4,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_4     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_6,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_6,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_6     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_8,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_8,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_8     ; Variable OUT - > parametre

suite_BAL       movlw   d'192'
                cpfslt  BALANCE             ; Si Balance < 192
                goto    fin_BAL

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_1,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_1,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_1     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_3,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_3,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_3     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_5,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_5,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_5     ; Variable OUT - > parametre

                movff   BALANCE,param_1     ; Variable IN1 - > parametre
                movff   LEVEL_7,param_2     ; Variable IN2 - > parametre
                clrf    param_3             ; MINI - > parametre
                movff   MAX_7,param_4       ; Maxi - > parametre
                call    FONCT_LEVEL         ; Appel Fonction
                movff   param_5,LEVEL_7     ; Variable OUT - > parametre
fin_BAL

;----------------------------- LINEAR ------------------------------- 1 --------
Linear_1        btfss   LINEAR_ENABLE,0
                goto    Linear_2

                movff   LINEAR_1_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_1,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_1,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_1         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 2 --------
Linear_2        btfss   LINEAR_ENABLE,1
                goto    Linear_3

                movff   LINEAR_2_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_1,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_2,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_2         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 3 --------
Linear_3        btfss   LINEAR_ENABLE,2
                goto    Linear_4

                movff   LINEAR_3_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_3,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_3,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_3         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 4 --------
Linear_4        btfss   LINEAR_ENABLE,3
                goto    Linear_5

                movff   LINEAR_4_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_4,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_4,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_4         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 5 --------
Linear_5        btfss   LINEAR_ENABLE,4
                goto    Linear_6

                movff   LINEAR_5_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_5,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_5,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_5         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 6 --------
Linear_6        btfss   LINEAR_ENABLE,5
                goto    Linear_7

                movff   LINEAR_6_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_6,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_6,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_6         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 7 --------
Linear_7        btfss   LINEAR_ENABLE,6
                goto    Linear_8

                movff   LINEAR_7_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_7,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_7,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_7         ; Variable OUT - > parametre

;----------------------------- LINEAR ------------------------------- 8 --------
Linear_8        btfss   LINEAR_ENABLE,7
                goto    Linear_fin

                movff   LINEAR_8_Val,param_1    ; Variable IN1 - > parametre
                movff   LEVEL_8,param_2      ; Variable IN2 - > parametre
                clrf    param_3                 ; MINI - > parametre
                movff   MAX_8,param_4           ; Maxi - > parametre
                call    FONCT_LEVEL             ; Appel Fonction
                movff   param_5,LEVEL_8         ; Variable OUT - > parametre
Linear_fin

;----------------------------- MUTE --------------------------------- 1 --------
Mute_1          btfss   MUTE_ENABLE,0
                goto    Mute_2
                clrf    LEVEL_1
;----------------------------- MUTE --------------------------------- 2 --------
Mute_2          btfss   MUTE_ENABLE,1
                goto    Mute_3
                clrf    LEVEL_2
;----------------------------- MUTE --------------------------------- 3 --------
Mute_3          btfss   MUTE_ENABLE,2
                goto    Mute_4
                clrf    LEVEL_3
;----------------------------- MUTE --------------------------------- 4 --------
Mute_4          btfss   MUTE_ENABLE,3
                goto    Mute_5
                clrf    LEVEL_4
;----------------------------- MUTE --------------------------------- 5 --------
Mute_5          btfss   MUTE_ENABLE,4
                goto    Mute_6
                clrf    LEVEL_5
;----------------------------- MUTE --------------------------------- 6 --------
Mute_6          btfss   MUTE_ENABLE,5
                goto    Mute_7
                clrf    LEVEL_6
;----------------------------- MUTE --------------------------------- 7 --------
Mute_7          btfss   MUTE_ENABLE,6
                goto    Mute_8
                clrf    LEVEL_7
;----------------------------- MUTE --------------------------------- 8 --------
Mute_8          btfss   MUTE_ENABLE,7
                goto    Mute_fin
                clrf    LEVEL_8
Mute_fin

;****************************** FIN ********************************************
Exit            return                  ; retour du sous programme
			    END
