;*******************************************************************************
;    Filename:	    CONSTANT                                                   *
;    Date:       	22/02/2013                                                 *
;    File Version:	1.0                                                        *
;                                                                              *
;    Author:        Philippe DOUILLARD                                         *
;*******************************************************************************
;  SUB ROUTINE                                                                 *
;                                                                              *
;  Ecriture des valeurs constante en mmoire flash                             *
;                                                                              *
;*******************************************************************************


;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern Main

;*********************** ADRESSE DES TABLES ************************************
TABLE_S0    EQU      0x0003000

;************************* SOUS ROUTINE ****************************************
PROG        CODE

constantes
            global constantes

;---------- EXIT ---------------------------------------------------------------
exit	    return          ; retour du sous programme

;*************** TABLE en memoire FLASH ****************************************

                org     TABLE_S0

;-------------- Fonte Standard -------------------------------------------------

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 0
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0x1E00,0x0000,0x003E   ; Caractere 1
                DATA 0x7E00,0x0000,0x00FE
                DATA 0xFE01,0x0300,0x00FE
                DATA 0xDE07,0x0F00,0x009E
                DATA 0x1E1F,0x3E00,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0x1E00,0x0000,0x001E
                DATA 0xFF03,0x03F0,0xF0FF
                DATA 0xFF03,0x03F0,0xF0FF

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 2
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x0000,0x001F,0x3E00
                DATA 0x0000,0x007E,0xFC00
                DATA 0x0100,0x00F8,0xF003
                DATA 0x0700,0x00E0,0xC00F
                DATA 0x1F00,0x0080,0x003F
                DATA 0x7E00,0x0000,0x00FC
                DATA 0xF801,0x0300,0x00F0
                DATA 0xE007,0x0F00,0x00C0
                DATA 0x801F,0x3F00,0x0000
                DATA 0xFF7F,0xFFFF,0xFFFF
                DATA 0xFFFF,0xFFFF,0xFFFF

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 3
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0x000F,0x0F00
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0x001F,0x3E00
                DATA 0x0000,0x007E,0xFC00
                DATA 0xFF0F,0x0FF8,0xF0FF
                DATA 0xFF0F,0x0FF0,0xF8FF
                DATA 0x0000,0x00FC,0x7E00
                DATA 0x0000,0x003E,0x1F00
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0x0000,0x00F8,0xF801   ; Caractere 4
                DATA 0x0300,0x00F8,0xF807
                DATA 0x0F00,0x00F8,0xF81F
                DATA 0x3F00,0x0078,0x787E
                DATA 0xFC00,0x0178,0x78F8
                DATA 0xF003,0x0778,0x78E0
                DATA 0xC00F,0x1F78,0x7880
                DATA 0x003F,0x7E78,0x7800
                DATA 0x00FC,0xF878,0x7800
                DATA 0x00F0,0xFF78,0xFFFF
                DATA 0xFFFF,0xFFFF,0xFFFF
                DATA 0xFFFF,0x00FF,0x7800
                DATA 0x0000,0x0078,0x7800
                DATA 0x0000,0x0078,0x7800
                DATA 0x0000,0x0078,0x7800
                DATA 0x0000,0x0078,0x7800

                DATA 0xFFFF,0xFFFF,0xFFFF   ; Caractere 5
                DATA 0xFFFF,0xFFFF,0xFFFF
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0xFFFF,0xFFC0,0xF0FF
                DATA 0xFFFF,0xFFF8,0xFCFF
                DATA 0x0000,0x00FE,0x7F00
                DATA 0x0000,0x003F,0x1F00
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0xF00F,0x0F00
                DATA 0x00F8,0xFC1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 6
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83F,0x1F00
                DATA 0x00F0,0xF00F,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0x00F0,0xF000,0x0000
                DATA 0xFFF1,0xF780,0xE0FF
                DATA 0xFFFF,0xFFF0,0xF8FF
                DATA 0x00FF,0xFEFC,0x7E00
                DATA 0x00FC,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0xFFFF,0xFFFF,0xFFFF   ; Caractere 7
                DATA 0xFFFF,0xFFFF,0xFFFF
                DATA 0x0000,0x003E,0x3E00
                DATA 0x0000,0x007C,0x7C00
                DATA 0x0000,0x00F8,0xF800
                DATA 0x0100,0x00F0,0xF001
                DATA 0x0300,0x00E0,0xE003
                DATA 0x0700,0x00C0,0xF8FF
                DATA 0xFF00,0x00F8,0xF8FF
                DATA 0xFF00,0x00F8,0x001F
                DATA 0x3E00,0x0000,0x003E
                DATA 0x7C00,0x0000,0x007C
                DATA 0xF800,0x0000,0x00F8
                DATA 0xF001,0x0100,0x00F0
                DATA 0xE003,0x0300,0x00E0
                DATA 0xC007,0x0700,0x00C0

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 8
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3E00
                DATA 0x007E,0x3F7E,0xFC00
                DATA 0xFF1F,0x0FF8,0xF0FF
                DATA 0xFF0F,0x1FF0,0xF8FF
                DATA 0x003F,0x7EFC,0x7E00
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0xFF07,0x1FE0,0xF8FF   ; Caractere 9
                DATA 0xFF3F,0x7FFC,0xFEFF
                DATA 0x007C,0xF83E,0x1F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F0,0xF00F,0x0F00
                DATA 0x00F8,0x7C1F,0x3F00
                DATA 0x007E,0x3F7F,0xFF00
                DATA 0xFF1F,0x0FFF,0xFFFF
                DATA 0xFF07,0x01FF,0xEFFF
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0x000F,0x0F00
                DATA 0x0000,0xF00F,0x0F00
                DATA 0x00F8,0xFC1F,0x3E00
                DATA 0xFF7F,0x3FFE,0xFCFF
                DATA 0xFF1F,0x07F8,0xE0FF

                DATA 0x2020,0x2020,0x2020    ; Remplissage 2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020,0x2020
                DATA 0x2020,0x2020

;------ Lignes de texte --------------------------------- 0x3400 ---------------

        DATA 0x5953,0x5453,0x4D45,0x2020,0x2020,0x2020  ; 00 - SYSTEM
        DATA 0x5541,0x4944,0x204F,0x5020,0x4F52,0x2020  ; 01 - SYSTEM OK
        DATA 0x5953,0x5453,0x4D45,0x4F20,0x204B,0x2020  ; 02 - AUDIO  PRO
        DATA 0x454D,0x554E,0x2020,0x2020,0x2020,0x2020  ; 03 - MENU
        DATA 0x454C,0x4556,0x204C,0x2020,0x2020,0x2020  ; 04 - LEVEL
        DATA 0x494C,0x454E,0x5241,0x2020,0x2020,0x2020  ; 05 - LINEAR
        DATA 0x5541,0x4944,0x204F,0x2020,0x2020,0x2020  ; 06 - AUDIO
        DATA 0x4F4C,0x4441,0x2020,0x2020,0x2020,0x2020  ; 07 - LOAD
        DATA 0x4153,0x4556,0x2020,0x2020,0x2020,0x2020  ; 08 - SAVE
        DATA 0x4552,0x414E,0x454D,0x2020,0x2020,0x2020  ; 09 - RENAME
        DATA 0x4148,0x4452,0x4157,0x4552,0x2020,0x2020  ; 10 - HARDWARE
        DATA 0x203C,0x5845,0x5449,0x3E20,0x2020,0x2020  ; 11 - < EXIT >
        DATA 0x4956,0x5553,0x4920,0x4F2F,0x4520,0x5058  ; 12 - VISU I/O EXP
        DATA 0x4E49,0x2020,0x2020,0x2020,0x2020,0x2020  ; 13 - IN
        DATA 0x554F,0x2054,0x2020,0x2020,0x2020,0x2020  ; 14 - OUT
        DATA 0x4956,0x5553,0x4920,0x4F2F,0x5320,0x4950  ; 15 - VISU I/O SPI
        DATA 0x4956,0x5553,0x4920,0x4F2F,0x5020,0x4349  ; 16 - VISU I/O PIC
        DATA 0x554F,0x2054,0x454C,0x4556,0x204C,0x2020  ; 17 - OUT LEVEL
        DATA 0x414D,0x2058,0x2020,0x2020,0x2020,0x2020  ; 18 - MAX
        DATA 0x464F,0x5346,0x5445,0x2020,0x2020,0x2020  ; 19 - OFFSET
        DATA 0x4244,0x2020,0x2020,0x2020,0x2020,0x2020  ; 20 - DB
        DATA 0x4F43,0x314E,0x2020,0x2020,0x2020,0x2020  ; 21 - CON1
        DATA 0x5453,0x5441,0x2020,0x2020,0x2020,0x2020  ; 22 - STAT
        DATA 0x5542,0x4646,0x2020,0x2020,0x2020,0x2020  ; 23 - BUFF
        DATA 0x4750,0x3141,0x2020,0x2020,0x2020,0x2020  ; 24 - PGA1
        DATA 0x4750,0x3241,0x2020,0x2020,0x2020,0x2020  ; 25 - PGA2
        DATA 0x4750,0x3341,0x2020,0x2020,0x2020,0x2020  ; 26 - PGA3
        DATA 0x4750,0x3441,0x2020,0x2020,0x2020,0x2020  ; 27 - PGA4
        DATA 0x5845,0x2050,0x2020,0x2020,0x2020,0x2020  ; 28 - EXP
        DATA 0x4956,0x5553,0x4920,0x4F2F,0x5220,0x3543  ; 29 - VISU I/O RC5
        DATA 0x4554,0x504D,0x204F,0x3152,0x4F20,0x204E  ; 30 - TEMPO R1 ON
        DATA 0x4554,0x504D,0x204F,0x3152,0x4F20,0x4646  ; 31 - TEMPO R1 OFF
        DATA 0x4554,0x504D,0x204F,0x3252,0x4F20,0x204E  ; 32 - TEMPO R2 ON
        DATA 0x4554,0x504D,0x204F,0x3252,0x4F20,0x4646  ; 33 - TEMPO R2 OFF
        DATA 0x4554,0x504D,0x204F,0x3352,0x4F20,0x204E  ; 34 - TEMPO R3 ON
        DATA 0x4554,0x504D,0x204F,0x3352,0x4F20,0x4646  ; 35 - TEMPO R3 OFF
        DATA 0x4554,0x504D,0x5620,0x4446,0x4520,0x4F43  ; 36 - TEMP VFD ECO
        DATA 0x4554,0x504D,0x5620,0x4446,0x4F20,0x4646  ; 37 - TEMP VFD OFF
        DATA 0x4F43,0x544E,0x4152,0x5453,0x4520,0x4F43  ; 38 - CONTRAST ECO
        DATA 0x4F43,0x544E,0x4152,0x5453,0x4D20,0x5841  ; 39 - CONTRAST MAX
        DATA 0x454C,0x2044,0x4F4D,0x4544,0x4520,0x4F43  ; 40 - LED MODE ECO
        DATA 0x454C,0x2044,0x4F4D,0x4544,0x4D20,0x5841  ; 41 - LED MODE MAX
        DATA 0x4F56,0x554C,0x454D,0x5320,0x4E45,0x4953  ; 42 - VOLUME SENSI
        DATA 0x435A,0x4E45,0x4F20,0x5450,0x4F49,0x204E  ; 43 - ZCEN OPTION
        DATA 0x4F56,0x554C,0x454D,0x4D20,0x4E49,0x2049  ; 44 - VOLUME MINI
        DATA 0x4F56,0x554C,0x454D,0x4D20,0x5841,0x2049  ; 45 - VOLUME MAXI
        DATA 0x4553,0x2043,0x2020,0x2020,0x2020,0x2020  ; 46 - SEC
        DATA 0x2025,0x2020,0x2020,0x2020,0x2020,0x2020  ; 47 - %
        DATA 0x5541,0x4944,0x204F,0x4F28,0x4246,0x294C  ; 48 - AUDIO (OFBL)
        DATA 0x5541,0x2E44,0x4220,0x4C41,0x4E41,0x4543  ; 49 - AUD. B ALANCE
        DATA 0x5541,0x4944,0x204F,0x554D,0x4554,0x2020  ; 50 - AUDIO MUTE
        DATA 0x4952,0x4847,0x2054,0x2020,0x2020,0x2020  ; 51 - RIGHT
        DATA 0x3128,0x3533,0x2937,0x2020,0x2020,0x2020  ; 52 - (1357)
        DATA 0x454C,0x5446,0x2020,0x2020,0x2020,0x2020  ; 53 - LEFT
        DATA 0x3228,0x3634,0x2938,0x2020,0x2020,0x2020  ; 54 - (2468)

TABEND
		END
