;*******************************************************************************
;  Filename:    page_AUDIO_Visu.asm                                            *
;                                                                              *
;  Version:  	27/02/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage des LEVEL OUT + diffrent attenuations (BAL, LEVEL, LINEAR...     *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      LINEAR_1_Val,LINEAR_2_Val,LINEAR_3_Val,LINEAR_4_Val
    extern      LINEAR_5_Val,LINEAR_6_Val,LINEAR_7_Val,LINEAR_8_Val
    extern      LEVEL_1,LEVEL_2,LEVEL_3,LEVEL_4,LEVEL_5,LEVEL_6,LEVEL_7,LEVEL_8
    extern      OFFSET_1,OFFSET_2,OFFSET_3,OFFSET_4,OFFSET_5
    extern      OFFSET_5,OFFSET_6,OFFSET_7,OFFSET_8
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9,temp1,temp2,temp3,temp5,memo3
    extern      EXP_IN,EXP_OUT,champ,BALANCE

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_AUDIO_Visu
        global page_AUDIO_Visu

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        btfss   memo3,1         ; Si FLAG (Rafraichissement)
        goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'48'           ; N Chaine
        movwf   param_3
        movlw   d'12'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- LIGNE ----------------------------------------------------------
        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'01'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'              ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle
                                                
        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

 ;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG

;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 1 -----------

                movlw   d'00'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_1,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 2 -----------

                movlw   d'17'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_2,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 3 -----------

                movlw   d'34'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_3,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 4 -----------

                movlw   d'51'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_4,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 5 -----------

                movlw   d'71'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_5,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 6 -----------

                movlw   d'88'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_6,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 7 -----------

                movlw   d'105'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_7,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LEVEL 8 -----------

                movlw   d'122'               ; X
                movwf   param_6
                movlw   d'32'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LEVEL_8,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 1 ----------

                movlw   d'00'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_1,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 2 ----------

                movlw   d'17'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_2,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 3 ----------

                movlw   d'34'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_3,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 4 ----------

                movlw   d'51'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_4,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 5 ----------

                movlw   d'71'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_5,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 6 ----------

                movlw   d'88'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_6,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 7 ----------

                movlw   d'105'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_7,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- OFFSET 8 ----------

                movlw   d'122'               ; X
                movwf   param_6
                movlw   d'25'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   OFFSET_8,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 1 ---------

                movlw   d'00'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 2 ---------

                movlw   d'17'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 3 ---------

                movlw   d'34'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 4 ---------

                movlw   d'51'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 5 ---------

                movlw   d'71'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 6 ---------

                movlw   d'88'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 7 ---------

                movlw   d'105'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- BALANCE 8 ---------

                movlw   d'122'               ; X
                movwf   param_6
                movlw   d'19'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 1 ----------

                movlw   d'00'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_1_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 2 ----------

                movlw   d'17'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_2_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 3 ----------

                movlw   d'34'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_3_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 4 ----------

                movlw   d'51'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_4_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 5 ----------

                movlw   d'71'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_5_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 6 ----------

                movlw   d'88'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_6_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 7 ----------

                movlw   d'105'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_7_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES vARIABLES -------------------- LINEAR 8 ----------

                movlw   d'122'               ; X
                movwf   param_6
                movlw   d'13'               ; Y
                movwf   param_7
                movlw   d'00'               ; FONTE
                movwf   param_8
                movff   LINEAR_8_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END