;*******************************************************************************
;  Filename:    page_Acceuil.asm                                               *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;               13/09/2012    V1.1      Gros caracteres                        *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                 			                       *
;  Affichage de la page d'acceuil                                              *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern  Main,par_rw0_rs0,par_rw0_rs1,dec8_bcd3,vol255_db_BCD
    extern  Commande_CLS

;********************** VARIABLES EXTERNES *************************************

        extern MASTER_Val,param_1,param_2,param_3,param_4,memo1,memo3
        extern MASTER_PV,MASTER_PU,MASTER_PD,MASTER_PS
        extern MASTER_Max
        extern ADRES_LOW, ADRES_HIGH
        extern temp1,temp2,temp3,memo3

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_Acceuil
                global page_Acceuil
                
;-------------- Test si Init ou Rafraichissement -------------------------------
                btfsc   memo3,0         ; Test si changement memu CLS si vrai
                goto    init

                btfss   memo3,1      ; Si FLAG (Rafraichissement)
                goto    saut6        ; Simon exit
                goto    affichage

init            call    Commande_CLS
                bcf     memo3,0

                movlw   0xff
                movwf   MASTER_PD   ; Charge valeur prcedente dcimale
                movwf   MASTER_PU   ; Charge valeur prcedente Unites
                movwf   MASTER_PV   ; Charge valeur prcedente Dizaines

;--------------- Niveau (Cadre exterieur) --------------------------------------
                movlw 0xF1          ; SET AREA
                movwf param_1		; Transfert parametre
                call par_rw0_rs0	; routine comunication paralelle

                movlw d'00'         ; X1
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw d'00'         ; Y1
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw d'04'         ; X2
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw d'31'         ; Y2
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x4F          ; CMD (Set Outline)
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

;--------------- dB ------------------------------------------------------------

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x42		; 'A' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x31		; '1' Espacing 1 pixels
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF0		; SET GRAFIC POSITION
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'129'		; X
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x64		; Caractere 'd'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x42		; Caractere 'B'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle


;--------------- Indication VIRGULE --------------------------------------------

                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'94'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'28'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'97'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x46		; CMD (Fill Area)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG

;--------------- Affichage volume (0-255) --------------------------------------

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x41		; 'A' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF0		; SET GRAFIC POSITION
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'8'		; X
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movff   MASTER_Val,param_1
                call    dec8_bcd3

                movf    param_1,0	; valeur des centaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movf    param_2,0		; valeur des dizaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
                
                movf    param_3,0		; valeur des unitees
                addlw   0x30		; adition avec caract?re '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle


;--------------- Niveau (Effacement interieur) ---------------------------------
                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'01'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'01'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'03'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movff MASTER_Val,param_1    ; Y2
                bcf STATUS,C                ; Efface la Carry
                RRCF param_1                ; Divise par 2
                bcf STATUS,C                ; Efface la Carry
                RRCF param_1                ; Divise par 2
                bcf STATUS,C                ; Efface la Carry
                RRCF param_1                ; Divise par 2
                bcf STATUS,C                ; Efface la Carry
                movlw d'31'
                subfwb param_1
                movff param_1,param_2
                call par_rw0_rs1            ; routine comunication paralelle


                movlw 0x43          ; CMD (Clear Area)
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

;--------------- Niveau mobil --------------------------------------------------
                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'01'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movff   MASTER_Val,param_1 ; Y1
                bcf     STATUS,C           ; Efface la Carry
                RRCF    param_1            ; Divise par 2
                bcf     STATUS,C           ; Efface la Carry
                RRCF    param_1            ; Divise par 2
                bcf     STATUS,C           ; Efface la Carry
                RRCF    param_1            ; Divise par 2
                bcf     STATUS,C           ; Efface la Carry
                movlw   d'32'
                subfwb  param_1
                movff   param_1,param_2
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'03'               ; X2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle
                movlw   d'31'               ; Y2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x46                ; CMD (Fill Area)
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle
;--------------- Niveau (Ligne curseur Max) ------------------------------------
                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'01'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movff   MASTER_Max,param_1	; Y1
                bcf     STATUS,C
                RRCF    param_1
                bcf     STATUS,C
                RRCF    param_1
                bcf     STATUS,C
                RRCF    param_1
                bcf     STATUS,C
                movlw   d'32'
                subfwb  param_1
                movff   param_1,param_2
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'03'               ; X2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                                            ; Y2
                movff   param_2,param_1     ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x49            ; CMD (Invert Area)
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

;--------------- Niveau (Fleche curseur Max) -----------------------------------
                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x42		; 'B' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF0		; SET GRAFIC POSITION
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'06'		; X
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                        		; Y
                movff   param_2,param_1	; Transfert parametre
                movlw   0x04
                addwf   param_1
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x1E		; 'fleche'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

;--------------- Indication MUTE -----------------------------------------------

                btfss   memo3,3     ; Test si FLAG MUTE
                goto    mute_OFF

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x41		; 'A' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x41		; 'A' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
                movlw   0xF0		; SET GRAFIC POSITION
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'14'		; X
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'7'		; Y
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x4D		; Caractere 'M'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x55		; Caractere 'U'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x54		; Caractere 'T'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x45		; Caractere 'E'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'12'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'32'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'8'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x4F		; CMD (Set Outline)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
                goto    mute_exit

mute_OFF        movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'12'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'32'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'8'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x43		; CMD (Clear Area)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
mute_exit
;--------------- Indication NUMERO PRESELECTION --------------------------------

                movlw   0xF2		; SET FONT
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   0x41		; 'A' Font 5x7
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF0		; SET GRAFIC POSITION
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'134'		; X
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'7'		; Y
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x31		; Caractere '1'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'132'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'138'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'08'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x4F		; CMD (Set Outline)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle


;--------------- GROS CARACTERE DIZAINES ---------------------------------------

                movff   MASTER_Val,param_1
                call    vol255_db_BCD

                movff   param_1,temp1   ; Sauve valeur des dizaines
                movff   param_2,temp2   ; Sauve valeur des unites
                movff   param_3,temp3   ; Sauve valeur des decimales

                movf    MASTER_PD,0     ; Charge valeur actuel Centaine
                cpfseq  temp1           ; Compare avec valeur precedente
                goto    saut1           ; Affichage si different
                goto    saut2           ; Pas affichage si identique

saut1           movlw   d'96'           ; Nb octet
                mulwf   temp1,1         ; Index
                movlw   0x00            ; Valeur adresse LOW
                addwf   PRODL,0         ; Addtionne avec index calcul LOW
                movwf   ADRES_LOW       ; Transfert vers ADRES_LOW
                movlw   0x30            ; Valeur adresse LOW
                addwf   PRODH,0         ; Addtionne avec index calcul HIGH
                movwf   ADRES_HIGH      ; Transfert vers ADRES_HIGH

                movff   ADRES_HIGH,TBLPTRH  ; Charge Adresse HIGH
                movff   ADRES_LOW,TBLPTRL   ; Charge Adresse LOW
                
;--------------- Affichage DIZAINES --------------------------------------------
                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'40'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'63'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x48		; CMD (SENS H)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'96'
                movwf   param_2

loop2           tblrd*+                 ; lire un octet, pointer sur le suivant
                movff   TABLAT,param_1
                call    par_rw0_rs1	; routine comunication paralelle

                decfsz  param_2         ; dcrmenter compteur d?octets
                bra     loop2

;--------------- GROS CARACTERE unites -----------------------------------------

saut2           movf    MASTER_PU,0     ; Charge valeur actuel Centaine
                cpfseq  temp2           ; Compare avec valeur precedente
                goto    saut3           ; Affichage si different
                goto    saut4           ; Pas affichage si identique

saut3           movlw   d'96'           ; Nb octet
                mulwf   temp2,1         ; Index
                movlw   0x00            ; Valeur adresse LOW
                addwf   PRODL,0         ; Addtionne avec index calcul LOW
                movwf   ADRES_LOW       ; Transfert vers ADRES_LOW
                movlw   0x30            ; Valeur adresse LOW
                addwf   PRODH,0         ; Addtionne avec index calcul HIGH
                movwf   ADRES_HIGH      ; Transfert vers ADRES_HIGH

                movff   ADRES_HIGH,TBLPTRH  ; Charge Adresse HIGH
                movff   ADRES_LOW,TBLPTRL   ; Charge Adresse LOW

;--------------- Affichage Unitees ---------------------------------------------
                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'66'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'89'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x48		; CMD (SENS H)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'96'
                movwf   param_2

loop3           tblrd*+                 ; lire un octet, pointer sur le suivant
                movff   TABLAT,param_1
                call    par_rw0_rs1	; routine comunication paralelle

                decfsz  param_2          ; dcrmenter compteur d'octets
                bra     loop3

;--------------- GROS CARACTERE virgule ----------------------------------

saut4           movf    MASTER_PV,0     ; Charge valeur actuel Centaine
                cpfseq  temp3           ; Compare avec valeur precedente
                goto    saut5           ; Affichage si different
                goto    saut6           ; Pas affichage si identique

saut5           movlw   d'96'           ; Nb octet
                mulwf   temp3,1         ; Index
                movlw   0x00            ; Valeur adresse LOW
                addwf   PRODL,0         ; Addtionne avec index calcul LOW
                movwf   ADRES_LOW       ; Transfert vers ADRES_LOW
                movlw   0x30            ; Valeur adresse LOW
                addwf   PRODH,0         ; Addtionne avec index calcul HIGH
                movwf   ADRES_HIGH      ; Transfert vers ADRES_HIGH

                movff   ADRES_HIGH,TBLPTRH  ; Charge Adresse HIGH
                movff   ADRES_LOW,TBLPTRL   ; Charge Adresse LOW

;--------------- Affichage VIRGULE ---------------------------------------------

                movlw   0xF1		; SET AREA
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs0	; routine comunication paralelle

                movlw   d'102'		; X1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'00'		; Y1
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'125'		; X2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'31'		; Y2
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   0x48		; CMD (SENS H)
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movlw   d'96'
                movwf   param_2

loop4           tblrd*+                 ; lire un octet, pointer sur le suivant
                movff   TABLAT,param_1
                call    par_rw0_rs1     ; routine comunication paralelle

                decfsz  param_2          ; dcrmenter compteur d?octets
                bra     loop4

;--------------- Indication SIGNE ----------------------------------------------

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x43            ; 'C' Font 10x14
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'22'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'24'           ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   param_4,param_1	; Transfert valeur signe vers parametre
                call    par_rw0_rs1     ; routine comunication paralelle

;--------------- Memorisation des valeurs precedente ---------------------------

saut6           movff   temp1,MASTER_PD  ; Charge valeur prcedente dcimale
                movff   temp2,MASTER_PU  ; Charge valeur prcedente Unites
                movff   temp3,MASTER_PV  ; Charge valeur prcedente Dizaines

exit
;--------------- exit ----------------------------------------------------------

                return              ; retour du sous programme
                END