;*******************************************************************************
;  Filename:    page_IO_EXP.asm                                                *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage des Inputs/Outputs  EXPANDER                                      *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern  Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern  Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9
    extern      temp1,temp2,temp3,temp5,memo3
    extern      champ
    
;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_IO_SPI
        global page_IO_SPI

;-------------- Test si rafraichissement ---------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        ;btfss   memo3,1         ; Si FLAG (Rafraichissement)
        ;goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'15'           ; N Chaine
        movwf   param_3
        movlw   d'12'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- LIGNE ----------------------------------------------------------
        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'01'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'138'               ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

                                                
        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (FILL Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

;-------------- Affichage Masque ------------------------------------------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'21'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'25'           ; Y
        movwf   param_2
        movlw   d'22'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'32'           ; Y
        movwf   param_2
        movlw   d'23'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'83'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'24'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'83'           ; X
        movwf   param_1
        movlw   d'25'           ; Y
        movwf   param_2
        movlw   d'25'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'83'           ; X
        movwf   param_1
        movlw   d'32'           ; Y
        movwf   param_2
        movlw   d'26'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'113'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'27'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movlw   d'113'           ; X
        movwf   param_1
        movlw   d'25'           ; Y
        movwf   param_2
        movlw   d'28'           ; N Chaine
        movwf   param_3
        movlw   d'4'            ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

 ;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG

 ;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage E/S (SSPCON1) ---------------------------------------------
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'23'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   SSPCON1,temp1

                btfss   temp1,0
                goto    IO_suite0
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit0
IO_suite0       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit0        btfss   temp1,1
                goto    IO_suite1
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit1
IO_suite1       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit1
                btfss   temp1,2
                goto    IO_suite2
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit2
IO_suite2       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit2
                btfss   temp1,3
                goto    IO_suite3
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit3
IO_suite3       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit3
                btfss   temp1,4
                goto    IO_suite4
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit4
IO_suite4       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit4
                btfss   temp1,5
                goto    IO_suite5
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit5
IO_suite5       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit5
                btfss   temp1,6
                goto    IO_suite6
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit6
IO_suite6       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit6
                btfss   temp1,7
                goto    IO_suite7
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit7
IO_suite7       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit7
;-------------- Affichage E/S (SSPSTAT) ---------------------------------------------
                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'23'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   SSPSTAT,temp1

                btfss   temp1,0
                goto    IO_suite10
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit10
IO_suite10      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit10       btfss   temp1,1
                goto    IO_suite11
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit11
IO_suite11       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit11
                btfss   temp1,2
                goto    IO_suite12
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit12
IO_suite12       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit12
                btfss   temp1,3
                goto    IO_suite13
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit13
IO_suite13       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit13
                btfss   temp1,4
                goto    IO_suite14
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit14
IO_suite14       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit14
                btfss   temp1,5
                goto    IO_suite15
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit15
IO_suite15      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit15
                btfss   temp1,6
                goto    IO_suite16
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit16
IO_suite16       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit16

                btfss   temp1,7
                goto    IO_suite17
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit17
IO_suite17       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit17

;-------------- Affichage E/S (SSPBUF) -----------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'23'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'33'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   SSPBUF,temp1
                btfss   temp1,0
                goto    IO_suite20
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit20
IO_suite20       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit20       btfss   temp1,1
                goto    IO_suite21
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit21
IO_suite21       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit21
                btfss   temp1,2
                goto    IO_suite22
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit22
IO_suite22       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit22
                btfss   temp1,3
                goto    IO_suite23
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit23
IO_suite23       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit23
                btfss   temp1,4
                goto    IO_suite24
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit24
IO_suite24       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit24
                btfss   temp1,5
                goto    IO_suite25
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit25
IO_suite25       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit25
                btfss   temp1,6
                goto    IO_suite26
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit26
IO_suite26       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit26

                btfss   temp1,7
                goto    IO_suite27
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit27
IO_suite27      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit27

;-------------- Affichage E/S (PGA CS 1) ---------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'104'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATB,1
                goto    IO_suite30
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit30
IO_suite30      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit30      
;-------------- Affichage E/S (PGA CS 2) ---------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'104'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATB,2
                goto    IO_suite40
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit40
IO_suite40      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit40

;-------------- Affichage E/S (PGA CS 3) ---------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'104'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'33'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATB,3
                goto    IO_suite50
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit50
IO_suite50      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit50

;-------------- Affichage E/S (PGA CS 4) ---------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'134'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATB,4
                goto    IO_suite60
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit60
IO_suite60      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit60

;-------------- Affichage E/S (EXP_CS) -----------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'134'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATC,7
                goto    IO_suite70
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit70
IO_suite70      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit70
;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END