;*******************************************************************************
;  Filename:    page_Intro.asm                                                      *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                 			                       *
;  Affichage de la page d'Intro                                                                       *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern Main,par_rw0_rs0,Delay_short,par_rw0_rs1,Commande_CLS,Commande_TEXT

;********************** VARIABLES EXTERNES *************************************
    extern param_1,param_2,param_3,param_4,param_5
;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_Intro
                global page_Intro

;-------------- Sous routine ---------------------------------------------------

                call Commande_CLS   ; efface ecran VFD

                movlw 0xF2          ; SET FONT
                movwf param_1       ; Transfert parametre
                call par_rw0_rs0    ; routine comunication paralelle

                movlw 0x43          ; 'C' Font 10x14
                movwf param_1       ; Transfert parametre
                call par_rw0_rs1    ; routine comunication paralelle

                movlw 0xF0          ; SET GRAFIC POSITION
                movwf param_1       ; Transfert parametre
                call par_rw0_rs0    ; routine comunication paralelle

                movlw d'55'          ; X
                movwf param_1       ; Transfert parametre
                call par_rw0_rs1    ; routine comunication paralelle

                movlw 0x0E          ; Y
                movwf param_1       ; Transfert parametre
                call par_rw0_rs1    ; routine comunication paralelle

                movlw 0x50          ; 'P'
                movwf param_1       ; Transfert parametre
                call par_rw0_rs1    ; routine comunication paralelle

                movlw 0x48          ; 'H'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x44          ; 'D'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw   d'54'           ; X
                movwf   param_1
                movlw   d'21'           ; Y
                movwf   param_2
                movlw   d'01'           ; N Chaine
                movwf   param_3
                movlw   d'11'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'00'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'32'           ; Y
                movwf   param_2
                movlw   d'02'           ; N Chaine
                movwf   param_3
                movlw   d'10'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
  
;--------------- Numro de version ---------------------------------------------

                movlw 0xF2          ; SET FONT
                movwf param_1		; Transfert parametre
                call par_rw0_rs0	; routine comunication paralelle

                movlw 0x32          ; '2' Spacing 2 pixels
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0xF0          ; SET GRAFIC POSITION
                movwf param_1		; Transfert parametre
                call par_rw0_rs0	; routine comunication paralelle

                movlw d'114'          ; X
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x20          ; Y
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x56          ; 'V'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x31          ; '1'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x2E          ; '.'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x31          ; '1'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

                movlw 0x32          ; '2'
                movwf param_1		; Transfert parametre
                call par_rw0_rs1	; routine comunication paralelle

;--------------- exit ----------------------------------------------------------

		return              ; retour du sous programme
			
		END
