;*******************************************************************************
;  Filename:	    vol255_db_BCD.asm                                            *
;                                                                              *
;  Version:         01/09/2012    V1.0      Version originale                  *
;                                                                              *
;                                                                              *
;  Author:          Philippe DOUILLARD                                         *
;*******************************************************************************
;  SUB ROUTINE                                                                 *
;                                 			                       *
;	Entree		param_1		valeur 8 bit 0-255                     *
;                                                                              *
;	Sortie		param_1		Octet BCD Dizaine                      *
;			param_2		Octet BCD Unites                       *
;			param_3         Octet BCD decimale                     *
;			param_4         Octet BCD signe                        *
;                                                                              *
;	Temporaire	temp1 		Valeur en conversion                   *
;			temp2		Pas                                    *
;			temp3		                                       *
;  									       *
;*******************************************************************************


;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	extern temp1, temp2, temp3, temp4, param_1,param_2,param_3,param_4
	extern Main

;************************* SOUS ROUTINE ****************************************

PROG CODE

vol255_db_BCD
                global vol255_db_BCD
;------------------------- PAGE SELECT -----------------------------------------

                BCF     STATUS,5            ; Select BANK 0
		BCF     STATUS,6            ; par defaut

;-------------- Division par 2 + Dtection Virgule -----------------------------

                movff   param_1,temp1    
                bcf     STATUS,C        ; Efface la Carry
                RRCF    temp1           ; Divise par 2
                bc      virgule5        ; Si carry alors .5
                goto    virgule0        ; Sinon          .0
virgule5        movlw   d'5'
                movwf   param_3
                goto    exit1
virgule0        movlw   d'0'
                movwf   param_3
exit1
;-------------- Dtection signe + Mise en forme --------------------------------

                movlw   d'96'
                subwf   temp1           ; temp1 = temp1 - 96

                movlw   d'192'
                cpfslt  param_1         ; Si param_1 < 192 alors negatif
                goto    suite           ; Sinon goto suite
                goto    negatif         ; Saute a negatig
suite           movlw   d'192'          
                cpfsgt  param_1         ; Si param_1 > 192 alors positif
                goto    egal            ; Sinon goto egal
                goto    positif
                goto    exit2

negatif         movlw   0x2D
                movwf   param_4
                comf    temp1           ; Complemente temp1 (passe en positif)
                btfsc   param_3,0
                goto    impaire
paire           movlw   d'01'
                addwf   temp1
                goto    exit2
impaire         goto    exit2

positif         movlw   0x2B
                movwf   param_4
                goto    exit2

egal            movlw   0x20
                movwf   param_4
exit2

;-------------- Detection Dizaines -> BCD --------------------------------------

		clrf temp2              ; Pas = 0
		movff temp1,temp3       ; W = temp2 	(valeur 8 bits)
;dec8_bcd3_2	movwf temp2             ; temp2 = W	(valeur 8 bits)
			
dec8_bcd3_2	incf temp2,1            ; Pas = pas+1
			
		movlw 0x0A              ; W = 10
                subwf temp3,1           ; temp3 = temp3 -10
		btfsc STATUS,C          ; Si résultat <0 alors saute
		goto dec8_bcd3_2        ; SINON boucle
			
		movlw 0x01              ; W = 1
		subwf temp2,0           ; pas = pas - 1
		movwf param_1           ; param_2 = pas (dizaines)

;-------------- unitees -> BCD -------------------------------------------------

		movlw   d'10'
                addwf   temp3,1         ; temp3 = temp3 + 10
                movff   temp3,param_2   ; param_3 = temp2

;------- EXIT -----------------------------------
	      	return          ; retour du sous programme
		
		END
